#include "framework.h"

#include <cmath> //for sqrt (square root) function

//**************************************
#ifdef WIN32
	#include <windows.h>
#else
	#include <sys/time.h>
#endif

long getTime()
{
	#ifdef WIN32
		return GetTickCount();
	#else
		struct timeval tv;
		gettimeofday(&tv,NULL);
		return (int)(tv.tv_sec*1000 + (tv.tv_usec / 1000));
	#endif
}

// **************************************

Point::Point()
{
	x = y = z = 0.0f;
}

Point::Point(float x, float y, float z)
{
	this->x = x;
	this->y = y;
	this->z = z;
}

void Point::Random(float range)
{
	//rand returns a value between 0 and RAND_MAX
	x = (rand() / (double)RAND_MAX) * 2 * range - range; //value between -range and range
	y = (rand() / (double)RAND_MAX) * 2 * range - range; //value between -range and range
	z = (rand() / (double)RAND_MAX) * 2 * range - range; //value between -range and range
}

//*********************************
Matrix33::Matrix33()
{
	memset(data,0, sizeof(float) * 9);
}

void Matrix33::setIdentity()
{
	data[0]=1; data[1]=0; data[2]=0;
	data[3]=0; data[4]=1; data[5]=0;
	data[6]=0; data[7]=0; data[8]=1;
}

//multiply one matrix by the other and store the result in this one
void Matrix33::multiply( const Matrix33& m )
{
	//this matrix has to store the concatenation of both matrices
	//...
}

//multiply the vector by the matrix
void Matrix33::transform( Point& p )
{
	//p should be changed to have the transform
	//be aware of reusing the same container as input on the calculations
	//...
}

//assign a matrix to perform a transform
void Matrix33::setTranslation(float x, float y)
{
	//set the matrix data to be a translation matrix
	data[0]=1.0f; data[1]=0.0f; data[2]=x;
	data[3]=0.0f; data[4]=1.0f; data[5]=y;
	data[6]=0.0f; data[7]=0.0f; data[8]=1.0f;
}

void Matrix33::setRotation(float angle)
{
	//set the matrix data to be a rotation matrix
	//remember that the angle will be in DEGREES so convert it to radians
	//...
}

void Matrix33::setScale(float x, float y)
{
	//set the matrix data to be a scale matrix
	//...
}
